# -*- coding: utf-8 -*-
"""
Created on Wed Sep 23 06:55:10 2015

@author: antoine
"""


class pile():
    """
    Structure de données de pile

    Appeler pile() pour créer une pile vide. Les méthodes sont
        - empile
        - depile
        - est_vide
        - sommet
    """

    def __init__(self, _init_data=[]):
        self._p = []
        for el in _init_data:
            self.empile(el)

    def est_vide(self):
        """
        Teste si cette pile est vide ou non
        """
        return len(self._p) == 0

    def sommet(self):
        """
        Retourne le sommet de cette pile sans dépiler, renvoi une erreur si la pile est vide
        """
        if self.est_vide():
            raise ValueError("La pile est vide !")
        else:
            return self._p[-1]

    def empile(self, elt):
        """
        Empile des données dans cette pile

        elt : l'élément à empiler

        Retourne cette pile
        """
        self._p.append(elt)
        return self

    def depile(self):
        """
        Dépile un élément. Renvoie une erreur si la pile est vide
        """
        if self.est_vide():
            raise ValueError("La pile est vide !")
        else:
            return self._p.pop()

    def affiche(self):
        print(str(self))

    def __str__(self):
        return "\n".join(str(e) for e in self._p[::-1])

    def __repr__(self):
        return "pile(%s)" % str(self._p)
